package de.intevation.flys.artifacts.model;

import gnu.trove.TDoubleArrayList;


/**
 * A subclass of WQTimerange that stores besides W, Q and Timerange values
 * another double value.
 *
 * @author <a href="mailto:ingo.weinzierl@intevation.de">Ingo Weinzierl</a>
 */
public class HistoricalWQTimerange extends WQTimerange {

    protected TDoubleArrayList diffs;


    public HistoricalWQTimerange(String name) {
        super(name);

        diffs = new TDoubleArrayList();
    }


    public void add(double w, double q, double diff, Timerange t) {
        ws.add(w);
        qs.add(q);
        ts.add(t);
        diffs.add(diff);
    }


    /**
     * This method requires a 3dim double array for <i>res</i>!
     */
    @Override
    public double[] get(int idx, double[] res) {
        res[0] = ws.getQuick(idx);
        res[1] = qs.getQuick(idx);
        res[2] = diffs.getQuick(idx);

        return res;
    }


    public double[] getDiffs() {
        return diffs.toNativeArray();
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
